<?php

/* vim: set expandtab tabstop=4 shiftwidth=4 softtabstop=4: */

/**
 * コメント追加
 *
 * @package     NetCommons
 * @author      Noriko Arai,Ryuji Masukawa
 * @copyright   2006-2007 NetCommons Project
 * @license     http://www.netcommons.org/license.txt  NetCommons License
 * @project     NetCommons Project, supported by National Institute of Informatics
 * @access      public
 */
class Journal_Action_Main_Comment extends Action
{
    // リクエストパラメータを受け取るため
    var $block_id = null;
    var $post_id = null;
    var $comment_id = null;
    var $content = null;

    // バリデートによりセット
	var $journal_obj = null;
	var $post = null;

    // 使用コンポーネントを受け取るため
    var $db = null;
 	var $request = null;
 	var $journalView = null;
	var $whatsnewAction = null;

    // 値をセットするため
    var $comment_flag = null;

    /**
     * コメント追加
     *
     * @access  public
     */
    function execute()
    {
    	if(empty($this->comment_id)) {
	    	$params = array(
				"journal_id" => $this->journal_obj['journal_id'],
				"root_id" => $this->post_id,
				"parent_id" => $this->post_id,
				"title" => "Re:".$this->post['title'],
				"icon_name" => "",
				"content" => $this->content
			);
			$post_id = $this->db->insertExecute("journal_post", $params, true, "post_id");
			if($post_id === false) {
				return 'error';
			}
    	}else {
    		$params = array(
				"content" => $this->content
			);
    		$result = $this->db->updateExecute("journal_post", $params,  array("post_id"=>$this->comment_id), true);
    		if($result === false) {
				return 'error';
			}
    	}
    	
    	//--新着情報関連 Start--
		$count = $this->db->countExecute("journal_post", array("parent_id"=>$this->post_id));
		if ($count === false) {
			return 'error';
		}
		$journal_post = $this->db->selectExecute("journal_post", array("post_id"=>$this->post_id));
		if ($journal_post === false && !isset($journal_post[0])) {
			return 'error';
		}
		$time = timezone_date();
		if(intval($time) < intval($journal_post[0]['journal_date'])) {
			// 未来ならば、日誌の記事の時間をセット
			$time = $journal_post[0]['journal_date'];
		}
		
		$whatsnew = array(
			"unique_id" => $this->post_id,
			"title" => $this->post['title'],
			"description" => $this->post['content'],
			"action_name" => "journal_view_main_detail",
			"parameters" => "post_id=". $this->post_id . "&comment_flag=1",
			"count_num" => $count,
			"child_flag" => _ON,
			"insert_time" => $time,
			"insert_user_id" => $journal_post[0]['insert_user_id'],
			"insert_user_name" => $journal_post[0]['insert_user_name']
		);
		$result = $this->whatsnewAction->auto($whatsnew);
		if($result === false) {
			return 'error';
		}
		//--新着情報関連 End--

    	$this->comment_flag = _ON;
    	$this->request->setParameter("comment_flag", $this->comment_flag);
        return 'success';
    }
}
?>
