<?php

/* vim: set expandtab tabstop=4 shiftwidth=4 softtabstop=4: */

/**
 * 記事一覧画面表示アクションクラス
 *
 * @package	 NetCommons
 * @author	  Noriko Arai,Ryuji Masukawa
 * @copyright   2006-2007 NetCommons Project
 * @license	 http://www.netcommons.org/license.txt  NetCommons License
 * @project	 NetCommons Project, supported by National Institute of Informatics
 * @access	  public
 */
class Journal_View_Main_Init extends Action
{
	// リクエストパラメータを受け取るため
	var $journal_id = null;
	var $category_id = null;
	var $visible_item = null;
	var	$block_id = null;
	
	// バリデートによりセット
	var $journal_obj = null;

	// 使用コンポーネントを受け取るため
	var $journalView = null;
	var $session = null;
	var $mobileView = null;
 
	// 値をセットするため
	var $categories = null;
	var $journal_count = null;
	var $journal_list = null;
	var $block_num   = null;
	
	//ページ
	var $data_cnt	= 0;
	var $now_page	= null;
	var $total_page  = 0;
	var $next_link   = FALSE;
	var $prev_link   = FALSE;
	var $disp_begin  = 0;
	var $disp_end	= 0;
	var $link_array  = NULL;

	/**
	 * 記事一覧画面表示アクション
	 *
	 * @access  public
	 */
	function execute()
	{
		if(empty($this->journal_id)) {
			$this->journal_id = $this->journal_obj['journal_id'];
		}

		$this->categories = $this->journalView->getCatByJournalId($this->journal_id);
		if($this->categories === false) {
			return 'error';
		}

		$category_id = $this->session->getParameter(array("journal", $this->journal_id, "category_id"));
		if($this->category_id != "") {
			$this->session->setParameter(array("journal", $this->journal_id, "category_id"), $this->category_id);
		}else if($category_id != ""){
			$this->category_id = $category_id;
		}

		$visible_item = $this->session->getParameter(array("journal", $this->journal_id, "visible_item"));
		if($this->visible_item != "") {
			if($visible_item != "" && $this->visible_item != $visible_item) {
				$this->now_page = 1;
			}
			$this->session->setParameter(array("journal", $this->journal_id, "visible_item"), $this->visible_item);
		}else if($visible_item != ""){
			$this->visible_item = $visible_item;
		}else {
			$this->visible_item = $this->journal_obj['visible_item'];
		}

		$now_page = $this->session->getParameter(array("journal", $this->journal_id, "now_page"));
		if(!empty($this->now_page)) {
			$this->session->setParameter(array("journal", $this->journal_id, "now_page"), $this->now_page);
		}else if(!empty($now_page)){
			$this->now_page = $now_page;
		}

		$this->journal_count = $this->journalView->getPostCount($this->journal_id, $this->category_id);
		if($this->journal_count === false) {
			return 'error';
		}

		if(!empty($this->visible_item)) {
			$this->setPageInfo($this->journal_count, $this->visible_item, $this->now_page);
		}
		$this->journal_list = $this->journalView->getPostList($this->journal_id, $this->category_id, $this->visible_item, $this->disp_begin);
		if($this->journal_list === false) {
			return 'error';
		}

		if( $this->session->getParameter( "_mobile_flag" ) == true ) {
			$this->block_num = $this->mobileView->getCountForBlockInPageWithBlock( $this->block_id );
		}

		return 'success';
	}
	
	/**
	 * ページに関する設定を行います
	 *
	 * @param	int	disp_cnt	1ページ当り表示件数
	 * @param	int	now_page	現ページ
	 */
	function setPageInfo($data_cnt, $disp_cnt, $now_page = NULL){
		$this->data_cnt = $data_cnt;
		// now page
		$this->now_page = (NULL == $now_page) ? 1 : $now_page;
		// total page
		$this->total_page = ceil($this->data_cnt / $disp_cnt);
		if($this->total_page < $this->now_page) {
			$this->now_page = 1;
		}
		// link array {{
		if(($this->now_page - JOURNAL_FRONT_AND_BEHIND_LINK_CNT) > 0){
			$start = $this->now_page - JOURNAL_FRONT_AND_BEHIND_LINK_CNT;
		}else{
			$start = 1;
		}
		if(($this->now_page + JOURNAL_FRONT_AND_BEHIND_LINK_CNT) >= $this->total_page){
			$end = $this->total_page;
		}else{
			$end = $this->now_page + JOURNAL_FRONT_AND_BEHIND_LINK_CNT;
		}
		$i = 0;
		for($i = $start; $i <= $end; $i++){
			$this->link_array[] = $i;
		}
		// next link
		if($disp_cnt < $this->data_cnt){
			if($this->now_page < $this->total_page){
				$this->next_link = TRUE;
			}
		}
		// prev link
		if(1 < $this->now_page){
			$this->prev_link = TRUE;
		}
		// begin disp number
		$this->disp_begin = ($this->now_page - 1) * $disp_cnt;
		// end disp number
		$tmp_cnt = $this->now_page * $disp_cnt;
		$this->disp_end = ($this->data_cnt < $tmp_cnt) ? $this->data_cnt : $tmp_cnt;
	}
}
?>