<?php

/* vim: set expandtab tabstop=4 shiftwidth=4 softtabstop=4: */

/**
 * システム管理>>一般設定画面表示
 * 		一般設定項目を表示する
 *
 * @package     NetCommons
 * @author      Noriko Arai,Ryuji Masukawa
 * @copyright   2006-2007 NetCommons Project
 * @license     http://www.netcommons.org/license.txt  NetCommons License
 * @project     NetCommons Project, supported by National Institute of Informatics
 * @access      public
 */
class System_View_Main_General extends Action
{
	// リクエストパラメータを受け取るため
	
    // 使用コンポーネントを受け取るため
    var $session = null;
    var $configView = null;
    var $languagesView = null;
    var $pagesView = null;
    var $fileView = null;
    
    // フィルタによりセット
    
    // 値をセットするため
    var $config = null;
    var $languages = null;
    var $pages = null;
    var $upload_capacity = array();

	/**
	 * execute実行
	 *
	 * @access  public
	 */
    function execute()
    {
        $this->config =& $this->configView->getConfigByCatid(_SYS_CONF_MODID, _GENERAL_CONF_CATID);
        if ($this->config === false) {
            return 'error';
        }
        
        $this->languages =& $this->languagesView->getLanguagesList(null, null);
        if ($this->languages === false) {
        	return 'error';
        }
        
        // 選択可能なルーム一覧取得
        /*
    	$where_params = array(
    		'{pages}.private_flag' => _OFF,
    		'{pages}.page_id={pages}.room_id' => null,
			'thread_num' => 1,
			'space_type!='._SPACE_TYPE_UNDEFINED => null,
    	);
		*/
    	$where_params = array(
    		'{pages}.private_flag' => _OFF,
    		'{pages}.page_id={pages}.room_id' => null,
			'((thread_num = 1 AND space_type = '._SPACE_TYPE_GROUP.' AND private_flag = '._OFF.') OR '.
    		'(thread_num = 0 AND space_type !='._SPACE_TYPE_GROUP.' AND space_type !='._SPACE_TYPE_UNDEFINED.'))' => null
    	);
    	$order_params = array(
    		'{pages}.thread_num' => "ASC"
    	);
    	$this->pages =& $this->pagesView->getPages($where_params, $order_params);
    	if ($this->pages === false) {
    		return 'error';
    	}
    	// グループルームのアップロード最大容量
    	$upload_cap_arr = explode("|",SYSTEM_UPLOAD_CAPACITY);
    	foreach($upload_cap_arr as $upload_cap_value) {
    		$this->upload_capacity[$upload_cap_value] = $this->fileView->formatSize($upload_cap_value);
    	}
    	return 'success';
    }
}
?>
